﻿using System;
using System.Collections.Generic;
using System.IO;

namespace t4
{
    class Program
    {
        struct P
        {
            public int x, y;
            public P(int ix, int iy) { x = ix; y = iy; }
        };

        static void Main(string[] args)
        {
            StreamReader Input = new StreamReader("input.txt");
            string s = Input.ReadLine();
            string[] ss = s.Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);
            int N = int.Parse(ss[0]);
            int M = int.Parse(ss[1]);

            int xa = -1, ya = -1, xb = -1, yb = -1;
            int[,] W = new int[N, M];

            for (int i = 0; i < N; i++)
            {
                s = Input.ReadLine();
                for (int j = 0; j < M; j++)
                {
                    if (s[j] == 'A') { xa = i; ya = j; W[i, j] = int.MaxValue; }
                    else if (s[j] == 'B') { xb = i; yb = j; W[i, j] = int.MaxValue; }
                    else if (s[j] == '.') { W[i, j] = int.MaxValue; }
                    else W[i, j] = -1;
                }
            }

            Input.Close();

            Queue<P> Q = new Queue<P>();

            W[xb, yb] = -1;
            Q.Enqueue(new P(xb, yb));

            P[,] D = new P[N, M];

            while (Q.Count > 0)
            {
                P p = Q.Dequeue();
                int x, y, w;

                w = W[p.x, p.y] + 1;

                x = p.x - 1; y = p.y;
                while (x >= 0 && W[x, y] > w)
                {
                    W[x, y] = w; 
                    Q.Enqueue(new P(x, y));
                    D[x, y] = new P(1, 0);
                    x--;
                }
                
                x = p.x + 1; y = p.y;
                while (x < N && W[x, y] > w)
                {
                    W[x, y] = w;
                    Q.Enqueue(new P(x, y));
                    D[x, y] = new P(-1, 0);
                    x++;
                }

                x = p.x; y = p.y - 1;
                while (y >= 0 && W[x, y] > w)
                {
                    W[x, y] = w;
                    Q.Enqueue(new P(x, y));
                    D[x, y] = new P(0, 1);
                    y--;
                }

                x = p.x; y = p.y + 1;
                while (y < M && W[x, y] > w)
                {
                    W[x, y] = w;
                    Q.Enqueue(new P(x, y));
                    D[x, y] = new P(0, -1);
                    y++;
                }
            }

            W[xb, yb] = 0;

            StreamWriter Output = new StreamWriter("output.txt");
            
            if (W[xa, ya] == int.MaxValue)
                Output.WriteLine("There is no way");
            else
            {
                Output.WriteLine(W[xa, ya]);
                {
                    int x = xa, y = ya;
                    while (x != xb || y != yb)
                    {
                        Output.WriteLine("{0} {1}", x + 1, y + 1);
                        P d = D[x, y];
                        x += d.x;
                        y += d.y;
                    }
                    Output.WriteLine("{0} {1}", x + 1, y + 1);
                }
            }

            Output.Close();
        }
    }
}
